// UTFT_Demo_320x240_Serial (C)2014 Henning Karlsen
// web: http://www.henningkarlsen.com/electronics
// web: http://www.buydisplay.com
// This program is a demo of how to use most of the functions
// of the library with a supported display modules.
//
// This demo was made for serial modules with a screen 
// resolution of 320x240 pixels.
//
// This program requires the UTFT library.
//

#include <UTFT.h>
#include <UTouch.h>
// Declare which fonts we will be using
extern uint8_t SmallFont[];


// Initialize display
// ------------------
// Set the pins to the correct ones for your development board
//UTFT myGLCD(ER_TFTM024_3_3I,7,8,9,10);                // TFTM024-3       3-wire 9-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21)
//UTFT myGLCD(ER_TFTM024_3_4I,7,8,9,10,11);                // TFTM024-3   4-wire 8-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25)
//UTFT myGLCD(ER_TFTM024_3_3II,7,8,9,10);                // TFTM024-3     3-wire 9-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21) 
//UTFT myGLCD(ER_TFTM024_3_4II,7,8,9,10,11);                // TFTM024-3   4-wire 8-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25) 
//UTFT myGLCD(ER_TFTM024_3_8I,38,39,40,41);                // TFTM024-3      8-bit bus interface I     D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10)    DUE Board's PIN22-PIN29
//UTFT myGLCD(ER_TFTM024_3_16I,38,39,40,41);                // TFTM024-3     16-bit bus interface I      D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10) DB8-DB15(PIN11-PIN18)   DUE Board's PIN37-PIN30    LCD:DB8-DB15(PIN11-PIN18)  DUE Board's PIN22-PIN29
//UTFT myGLCD(ER_TFTM026_1_3I,7,8,9,10);                // TFTM026_1      3-wire 9-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21)
//UTFT myGLCD(ER_TFTM026_1_4I,7,8,9,10,11);                // TFTM026_1   4-wire 8-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25)
//UTFT myGLCD(ER_TFTM026_1_3II,7,8,9,10);                // TFTM026_1     3-wire 9-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21) 
//UTFT myGLCD(ER_TFTM026_1_4II,7,8,9,10,11);                // TFTM026_1   4-wire 8-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25) 
//UTFT myGLCD(ER_TFTM026_1_8I,38,39,40,41);                // TFTM026_1      8-bit bus interface I     D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10)    DUE Board's PIN22-PIN29
//UTFT myGLCD(ER_TFTM026_1_16I,38,39,40,41);                // TFTM026_1     16-bit bus interface I      D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10) DB8-DB15(PIN11-PIN18)   DUE Board's PIN37-PIN30    LCD:DB8-DB15(PIN11-PIN18)  DUE Board's PIN22-PIN29
//UTFT myGLCD(ER_TFTM028_4_3I,7,8,9,10);                // TFTM028-4       3-wire 9-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21)
//UTFT myGLCD(ER_TFTM028_4_4I,7,8,9,10,11);                // TFTM028-4    4-wire 8-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25)
//UTFT myGLCD(ER_TFTM028_4_3II,7,8,9,10);                // TFTM028-4     3-wire 9-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21) 
//UTFT myGLCD(ER_TFTM028_4_4II,7,8,9,10,11);                // TFTM028-4    4-wire 8-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25) 
//UTFT myGLCD(ER_TFTM028_4_8I,38,39,40,41);                // TFTM028-4       8-bit bus interface I     D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10)    DUE Board's PIN22-PIN29
//UTFT myGLCD(ER_TFTM028_4_16I,38,39,40,41);                //TFTM028-4      16-bit bus interface I      D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10) DB8-DB15(PIN11-PIN18)   DUE Board's PIN37-PIN30    LCD:DB8-DB15(PIN11-PIN18)  DUE Board's PIN22-PIN29
//UTFT myGLCD(ER_TFTM032_3_3I,7,8,9,10);                // TFTM032-3       3-wire 9-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21)
//UTFT myGLCD(ER_TFTM32_3_4I,7,8,9,10,11);                // TFTM032-3   4-wire 8-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25)
//UTFT myGLCD(ER_TFTM032_3_3II,7,8,9,10);                //TFTM032-3     3-wire 9-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21) 
UTFT myGLCD(ER_TFTM032_3_4II,7,8,9,10,11);                // TFTM032-3   4-wire 8-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25) 
//UTFT myGLCD(ER_TFTM032_3_8I,38,39,40,41);                // TFTM032-3      8-bit bus interface I     D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10)    DUE Board's PIN22-PIN29
//UTFT myGLCD(ER_TFTM032_3_16I,38,39,40,41);                // TFTM032-3    16-bit bus interface I      D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10) DB8-DB15(PIN11-PIN18)   DUE Board's PIN37-PIN30    LCD:DB8-DB15(PIN11-PIN18)  DUE Board's PIN22-PIN29

// Set the pins to the correct ones for your development board
// -----------------------------------------------------------
// Standard Arduino Uno/2009 Shield            : 15,10,14, 9, 8
// Standard Arduino Mega/Due shield            :  6, 5, 4, 3, 2
// CTE TFT LCD/SD Shield for Arduino Due       :  6, 5, 4, 3, 2
// Teensy 3.x TFT Test Board                   : 26,31,27,28,29
// ElecHouse TFT LCD/SD Shield for Arduino Due : 25,26,27,29,30
//
UTouch  myTouch( 6, 5, 4, 3, 2);

// Declare which fonts we will be using
extern uint8_t BigFont[];

int color = 0;
word colorlist[] = {VGA_WHITE, VGA_BLACK, VGA_RED, VGA_BLUE, VGA_GREEN, VGA_FUCHSIA, VGA_YELLOW, VGA_AQUA};
int  bsize = 4;

void drawColorMarkerAndBrushSize(int col)
{
  myGLCD.setColor(VGA_BLACK);
  myGLCD.fillRect(25, 0, 31, 239);
  myGLCD.fillRect(myGLCD.getDisplayXSize()-31, 161, myGLCD.getDisplayXSize()-1, 191);
  myGLCD.setColor(VGA_WHITE);
  myGLCD.drawPixel(25, (col*30)+15);
  for (int i=1; i<7; i++)
    myGLCD.drawLine(25+i, ((col*30)+15)-i, 25+i, ((col*30)+15)+i);
  
  if (color==1)
    myGLCD.setColor(VGA_WHITE);
  else
    myGLCD.setColor(colorlist[col]);
  if (bsize==1)
    myGLCD.drawPixel(myGLCD.getDisplayXSize()-15, 177);
  else
    myGLCD.fillCircle(myGLCD.getDisplayXSize()-15, 177, bsize);
    
  myGLCD.setColor(colorlist[col]);
}

void setup()
{
// Watterott
// ---------
// The following two lines are needed for the  display
// module to enable the backlight. If you are using any other 
// display module these lines should be commented out.
// -------------------------------------------------------------
  pinMode(12, OUTPUT);
  digitalWrite(12, HIGH);
// -------------------------------------------------------------

// DisplayModule
// -------------
// The following 4 lines are needed for the DM-TFT28-105 display
// module to set the SS/CS pins for the other devices connected 
// to the Arduino SPI pins. If you are using any other display
// module these lines should be commented out.
// -------------------------------------------------------------
//  pinMode(10,OUTPUT); digitalWrite(10,HIGH);  // TFT SS/CE
//  pinMode(8, OUTPUT); digitalWrite(8, HIGH);  // SD card SS/CE
//  pinMode(6, OUTPUT); digitalWrite(6, HIGH);  // Flash chip SS/CE
//  pinMode(4, OUTPUT); digitalWrite(4, HIGH);  // Touch controller SS/CE
// -------------------------------------------------------------


// Just get some random numbers
  randomSeed(analogRead(0));
  
// Setup the LCD
  myGLCD.InitLCD();
  myGLCD.setFont(SmallFont);

}

void loop()
{
  int buf[318];
  int x, x2;
  int y, y2;
  int r;
  myGLCD.setFont(SmallFont);
// Clear the screen and draw the frame
  myGLCD.clrScr();

  myGLCD.setColor(255, 0, 0);
  myGLCD.fillRect(0, 0, 319, 13);
  myGLCD.setColor(64, 64, 64);
  myGLCD.fillRect(0, 226, 319, 239);
  myGLCD.setColor(255, 255, 255);
  myGLCD.setBackColor(255, 0, 0);
  myGLCD.print("* EastRising Technology  *", CENTER, 1);
  myGLCD.setBackColor(64, 64, 64);
  myGLCD.setColor(255,255,0);
  myGLCD.print("<http://buydisplay.com>", CENTER, 227);

  myGLCD.setColor(0, 0, 255);
  myGLCD.drawRect(0, 14, 319, 225);

// Draw crosshairs
  myGLCD.setColor(0, 0, 255);
  myGLCD.setBackColor(0, 0, 0);
  myGLCD.drawLine(159, 15, 159, 224);
  myGLCD.drawLine(1, 119, 318, 119);
  for (int i=9; i<310; i+=10)
    myGLCD.drawLine(i, 117, i, 121);
  for (int i=19; i<220; i+=10)
    myGLCD.drawLine(157, i, 161, i);

// Draw sin-, cos- and tan-lines  
  myGLCD.setColor(0,255,255);
  myGLCD.print("Sin", 5, 15);
  for (int i=1; i<318; i++)
  {
    myGLCD.drawPixel(i,119+(sin(((i*1.13)*3.14)/180)*95));
  }
  
  myGLCD.setColor(255,0,0);
  myGLCD.print("Cos", 5, 27);
  for (int i=1; i<318; i++)
  {
    myGLCD.drawPixel(i,119+(cos(((i*1.13)*3.14)/180)*95));
  }

  myGLCD.setColor(255,255,0);
  myGLCD.print("Tan", 5, 39);
  for (int i=1; i<318; i++)
  {
    myGLCD.drawPixel(i,119+(tan(((i*1.13)*3.14)/180)));
  }

  delay(2000);

  myGLCD.setColor(0,0,0);
  myGLCD.fillRect(1,15,318,224);
  myGLCD.setColor(0, 0, 255);
  myGLCD.setBackColor(0, 0, 0);
  myGLCD.drawLine(159, 15, 159, 224);
  myGLCD.drawLine(1, 119, 318, 119);

// Draw a moving sinewave
  x=1;
  for (int i=1; i<(318*20); i++) 
  {
    x++;
    if (x==319)
      x=1;
    if (i>319)
    {
      if ((x==159)||(buf[x-1]==119))
        myGLCD.setColor(0,0,255);
      else
        myGLCD.setColor(0,0,0);
      myGLCD.drawPixel(x,buf[x-1]);
    }
    myGLCD.setColor(0,255,255);
    y=119+(sin(((i*1.1)*3.14)/180)*(90-(i / 100)));
    myGLCD.drawPixel(x,y);
    buf[x-1]=y;
  }

  delay(2000);
  
  myGLCD.setColor(0,0,0);
  myGLCD.fillRect(1,15,318,224);

// Draw some filled rectangles
  for (int i=1; i<6; i++)
  {
    switch (i)
    {
      case 1:
        myGLCD.setColor(255,0,255);
        break;
      case 2:
        myGLCD.setColor(255,0,0);
        break;
      case 3:
        myGLCD.setColor(0,255,0);
        break;
      case 4:
        myGLCD.setColor(0,0,255);
        break;
      case 5:
        myGLCD.setColor(255,255,0);
        break;
    }
    myGLCD.fillRect(70+(i*20), 30+(i*20), 130+(i*20), 90+(i*20));
  }

  delay(2000);
  
  myGLCD.setColor(0,0,0);
  myGLCD.fillRect(1,15,318,224);

// Draw some filled, rounded rectangles
  for (int i=1; i<6; i++)
  {
    switch (i)
    {
      case 1:
        myGLCD.setColor(255,0,255);
        break;
      case 2:
        myGLCD.setColor(255,0,0);
        break;
      case 3:
        myGLCD.setColor(0,255,0);
        break;
      case 4:
        myGLCD.setColor(0,0,255);
        break;
      case 5:
        myGLCD.setColor(255,255,0);
        break;
    }
    myGLCD.fillRoundRect(190-(i*20), 30+(i*20), 250-(i*20), 90+(i*20));
  }
  
  delay(2000);
  
  myGLCD.setColor(0,0,0);
  myGLCD.fillRect(1,15,318,224);

// Draw some filled circles
  for (int i=1; i<6; i++)
  {
    switch (i)
    {
      case 1:
        myGLCD.setColor(255,0,255);
        break;
      case 2:
        myGLCD.setColor(255,0,0);
        break;
      case 3:
        myGLCD.setColor(0,255,0);
        break;
      case 4:
        myGLCD.setColor(0,0,255);
        break;
      case 5:
        myGLCD.setColor(255,255,0);
        break;
    }
    myGLCD.fillCircle(100+(i*20),60+(i*20), 30);
  }
  
  delay(2000);
  
  myGLCD.setColor(0,0,0);
  myGLCD.fillRect(1,15,318,224);

// Draw some lines in a pattern
  myGLCD.setColor (255,0,0);
  for (int i=15; i<224; i+=5)
  {
    myGLCD.drawLine(1, i, (i*1.44)-10, 224);
  }
  myGLCD.setColor (255,0,0);
  for (int i=224; i>15; i-=5)
  {
    myGLCD.drawLine(318, i, (i*1.44)-11, 15);
  }
  myGLCD.setColor (0,255,255);
  for (int i=224; i>15; i-=5)
  {
    myGLCD.drawLine(1, i, 331-(i*1.44), 15);
  }
  myGLCD.setColor (0,255,255);
  for (int i=15; i<224; i+=5)
  {
    myGLCD.drawLine(318, i, 330-(i*1.44), 224);
  }
  
  delay(2000);
  
  myGLCD.setColor(0,0,0);
  myGLCD.fillRect(1,15,318,224);

// Draw some random circles
  for (int i=0; i<100; i++)
  {
    myGLCD.setColor(random(255), random(255), random(255));
    x=32+random(256);
    y=45+random(146);
    r=random(30);
    myGLCD.drawCircle(x, y, r);
  }

  delay(2000);
  
  myGLCD.setColor(0,0,0);
  myGLCD.fillRect(1,15,318,224);

// Draw some random rectangles
  for (int i=0; i<100; i++)
  {
    myGLCD.setColor(random(255), random(255), random(255));
    x=2+random(316);
    y=16+random(207);
    x2=2+random(316);
    y2=16+random(207);
    myGLCD.drawRect(x, y, x2, y2);
  }

  delay(2000);
  
  myGLCD.setColor(0,0,0);
  myGLCD.fillRect(1,15,318,224);

// Draw some random rounded rectangles
  for (int i=0; i<100; i++)
  {
    myGLCD.setColor(random(255), random(255), random(255));
    x=2+random(316);
    y=16+random(207);
    x2=2+random(316);
    y2=16+random(207);
    myGLCD.drawRoundRect(x, y, x2, y2);
  }

  delay(2000);
  
  myGLCD.setColor(0,0,0);
  myGLCD.fillRect(1,15,318,224);

  for (int i=0; i<100; i++)
  {
    myGLCD.setColor(random(255), random(255), random(255));
    x=2+random(316);
    y=16+random(209);
    x2=2+random(316);
    y2=16+random(209);
    myGLCD.drawLine(x, y, x2, y2);
  }

  delay(2000);
  
  myGLCD.setColor(0,0,0);
  myGLCD.fillRect(1,15,318,224);

  for (int i=0; i<10000; i++)
  {
    myGLCD.setColor(random(255), random(255), random(255));
    myGLCD.drawPixel(2+random(316), 16+random(209));
  }

  delay(2000);

  myGLCD.fillScr(0, 0, 255);
  myGLCD.setColor(255, 0, 0);
  myGLCD.fillRoundRect(80, 70, 239, 169);
  
  myGLCD.setColor(255, 255, 255);
  myGLCD.setBackColor(255, 0, 0);
   myGLCD.print("www.buydisplay.com", CENTER, 78); 
  myGLCD.print("That's it!", CENTER, 93);
  myGLCD.print("Restarting in a", CENTER, 119);
  myGLCD.print("few seconds...", CENTER, 132);
  
  myGLCD.setColor(0, 255, 0);
  myGLCD.setBackColor(0, 0, 255);
  myGLCD.print("Runtime: (msecs)", CENTER, 210);
  myGLCD.printNumI(millis(), CENTER, 225);
  
  delay (5000);
  
  
    myGLCD.clrScr();
  myGLCD.setFont(BigFont);

  myTouch.InitTouch();
  myTouch.setPrecision(PREC_HI);
  
  myGLCD.setColor(VGA_WHITE);
  myGLCD.drawLine(32,0,32,myGLCD.getDisplayYSize()-1);
  myGLCD.drawLine(myGLCD.getDisplayXSize()-32,0,myGLCD.getDisplayXSize()-32,myGLCD.getDisplayYSize()-1);
  myGLCD.print("C", myGLCD.getDisplayXSize()-24, 8);
  myGLCD.print("L", myGLCD.getDisplayXSize()-24, 24);
  myGLCD.print("E", myGLCD.getDisplayXSize()-24, 40);
  myGLCD.print("A", myGLCD.getDisplayXSize()-24, 56);
  myGLCD.print("R", myGLCD.getDisplayXSize()-24, 72);
  myGLCD.print("+", myGLCD.getDisplayXSize()-24, 136);
  myGLCD.print("-", myGLCD.getDisplayXSize()-24, 200);
  myGLCD.fillRect(myGLCD.getDisplayXSize()-32,96,myGLCD.getDisplayXSize()-1,128);
  myGLCD.drawLine(myGLCD.getDisplayXSize()-32,160,myGLCD.getDisplayXSize()-1,160);
  myGLCD.drawLine(myGLCD.getDisplayXSize()-32,192,myGLCD.getDisplayXSize()-1,192);
  myGLCD.drawLine(myGLCD.getDisplayXSize()-32,224,myGLCD.getDisplayXSize()-1,224);
  for (int i=0; i<8; i++)
  {
    myGLCD.setColor(colorlist[i]);
    myGLCD.fillRect(0, (i*30), 24, (((i+1)*30)-1));
  }
  drawColorMarkerAndBrushSize(color);
  
 while (true)// while (myTouch.dataAvailable() == true)
  {
    myTouch.read();
    x = myTouch.getX();
    y = myTouch.getY();
    if ((x!=-1) and (y!=-1))
    {
      if (x>(31+bsize) and (x<myGLCD.getDisplayXSize()-(31+bsize)))
      {
        if (bsize==1)
          myGLCD.drawPixel(x, y);
        else
          myGLCD.fillCircle(x, y, bsize);
      }
      else
      {
        if (x<(30+bsize))
        {
          if (y<240)
          {
            color = y / 30;
            drawColorMarkerAndBrushSize(color);
            while (myTouch.dataAvailable()) {};
            delay(50);
         }
        }
        else
        {
          if (y<96)
          {
            myGLCD.setColor(VGA_BLACK);
            myGLCD.fillRect(33, 0, myGLCD.getDisplayXSize()-33, myGLCD.getDisplayYSize()-1);
            myGLCD.setColor(colorlist[color]);
          }
          if ((y>128) and (y<160))
          {
            if (bsize<7)
            {
              bsize++;
              drawColorMarkerAndBrushSize(color);
              while (myTouch.dataAvailable()) {};
              delay(50);
            }
          }
          if ((y>160) and (y<192))
          {
              bsize=4;
              drawColorMarkerAndBrushSize(color);
              while (myTouch.dataAvailable()) {};
              delay(50);
          }
          if ((y>192) and (y<224))
          {
            if (bsize>1)
            {
              bsize--;
              drawColorMarkerAndBrushSize(color);
              while (myTouch.dataAvailable()) {};
              delay(50);
            }
          }
        }
      }
    }
  }  
  
  
}
