// UTouch_QuickDraw (C)2010-2014 Henning Karlsen
// web: http://www.henningkarlsen.com/electronics
//// web: http://www.buydisplay.com
// This program is a quick demo of how to use the library.
//
// This program requires the UTFT library.
//
// It is assumed that the display module is connected to an
// appropriate shield or that you know how to change the pin 
// numbers in the setup.
//

#include <UTFT.h>
#include <UTouch.h>


// Initialize display
// ------------------
// Set the pins to the correct ones for your development board
//UTFT myGLCD(ER_TFTM024_3_3I,7,8,9,10);                // TFTM024-3       3-wire 9-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21)
//UTFT myGLCD(ER_TFTM024_3_4I,7,8,9,10,11);                // TFTM024-3   4-wire 8-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25)
//UTFT myGLCD(ER_TFTM024_3_3II,7,8,9,10);                // TFTM024-3     3-wire 9-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21) 
//UTFT myGLCD(ER_TFTM024_3_4II,7,8,9,10,11);                // TFTM024-3   4-wire 8-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25) 
//UTFT myGLCD(ER_TFTM024_3_8I,38,39,40,41);                // TFTM024-3      8-bit bus interface I     D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10)    DUE Board's PIN22-PIN29
//UTFT myGLCD(ER_TFTM024_3_16I,38,39,40,41);                // TFTM024-3     16-bit bus interface I      D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10) DB8-DB15(PIN11-PIN18)   DUE Board's PIN37-PIN30    LCD:DB8-DB15(PIN11-PIN18)  DUE Board's PIN22-PIN29
//UTFT myGLCD(ER_TFTM026_1_3I,7,8,9,10);                // TFTM026_1      3-wire 9-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21)
//UTFT myGLCD(ER_TFTM026_1_4I,7,8,9,10,11);                // TFTM026_1   4-wire 8-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25)
//UTFT myGLCD(ER_TFTM026_1_3II,7,8,9,10);                // TFTM026_1     3-wire 9-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21) 
//UTFT myGLCD(ER_TFTM026_1_4II,7,8,9,10,11);                // TFTM026_1   4-wire 8-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25) 
//UTFT myGLCD(ER_TFTM026_1_8I,38,39,40,41);                // TFTM026_1      8-bit bus interface I     D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10)    DUE Board's PIN22-PIN29
//UTFT myGLCD(ER_TFTM026_1_16I,38,39,40,41);                // TFTM026_1     16-bit bus interface I      D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10) DB8-DB15(PIN11-PIN18)   DUE Board's PIN37-PIN30    LCD:DB8-DB15(PIN11-PIN18)  DUE Board's PIN22-PIN29
//UTFT myGLCD(ER_TFTM028_4_3I,7,8,9,10);                // TFTM028-4       3-wire 9-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21)
//UTFT myGLCD(ER_TFTM028_4_4I,7,8,9,10,11);                // TFTM028-4    4-wire 8-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25)
//UTFT myGLCD(ER_TFTM028_4_3II,7,8,9,10);                // TFTM028-4     3-wire 9-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21) 
//UTFT myGLCD(ER_TFTM028_4_4II,7,8,9,10,11);                // TFTM028-4    4-wire 8-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25) 
//UTFT myGLCD(ER_TFTM028_4_8I,38,39,40,41);                // TFTM028-4       8-bit bus interface I     D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10)    DUE Board's PIN22-PIN29
//UTFT myGLCD(ER_TFTM028_4_16I,38,39,40,41);                //TFTM028-4      16-bit bus interface I      D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10) DB8-DB15(PIN11-PIN18)   DUE Board's PIN37-PIN30    LCD:DB8-DB15(PIN11-PIN18)  DUE Board's PIN22-PIN29
//UTFT myGLCD(ER_TFTM032_3_3I,7,8,9,10);                // TFTM032-3       3-wire 9-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21)
//UTFT myGLCD(ER_TFTM32_3_4I,7,8,9,10,11);                // TFTM032-3   4-wire 8-bit data serial interface I      SDA(PIN27),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25)
//UTFT myGLCD(ER_TFTM032_3_3II,7,8,9,10);                //TFTM032-3     3-wire 9-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21) 
UTFT myGLCD(ER_TFTM032_3_4II,7,8,9,10,11);                // TFTM032-3   4-wire 8-bit data serial interface II      SDI(PIN27)(data input,SDO not used),  SCL(PIN24),  /CS(PIN23),  /RST(PIN21),  D/C(PIN25) 
//UTFT myGLCD(ER_TFTM032_3_8I,38,39,40,41);                // TFTM032-3      8-bit bus interface I     D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10)    DUE Board's PIN22-PIN29
//UTFT myGLCD(ER_TFTM032_3_16I,38,39,40,41);                // TFTM032-3    16-bit bus interface I      D/C(PIN24)  /WR(PIN25)  /CS(PIN23)  /RST(PIN21)     LCD:DB0-DB7(PIN3-PIN10) DB8-DB15(PIN11-PIN18)   DUE Board's PIN37-PIN30    LCD:DB8-DB15(PIN11-PIN18)  DUE Board's PIN22-PIN29

// ----------------------
// Set the pins to the correct ones for your development board
// -----------------------------------------------------------
// Standard Arduino Uno/2009 Shield            : 15,10,14, 9, 8
// Standard Arduino Mega/Due shield            :  6, 5, 4, 3, 2
// CTE TFT LCD/SD Shield for Arduino Due       :  6, 5, 4, 3, 2
// Teensy 3.x TFT Test Board                   : 26,31,27,28,29
// ElecHouse TFT LCD/SD Shield for Arduino Due : 25,26,27,29,30
//
UTouch  myTouch( 6, 5, 4, 3, 2);

void setup()
{
 // The following two lines are needed for the  display
// module to enable the backlight. If you are using any other 
// display module these lines should be commented out.
// -------------------------------------------------------------
  pinMode(12, OUTPUT);
  digitalWrite(12, HIGH);
// -------------------------------------------------------------
   
  myGLCD.InitLCD();
  myGLCD.clrScr();

  myTouch.InitTouch();
  myTouch.setPrecision(PREC_MEDIUM);
}

void loop()
{
  long x, y;
  
  while (myTouch.dataAvailable() == true)
  {
    myTouch.read();
    x = myTouch.getX();
    y = myTouch.getY();
    if ((x!=-1) and (y!=-1))
    {
      myGLCD.drawPixel (x, y);
    }
  }
}

